/*IN FISH AT EGOI I TRUST*/
/*IN FISH AT EGOI I TRUST*/
/*IN FISH AT EGOI I TRUST*/
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll,ll> pll;
typedef pair<pll,ll> ppl;
typedef long double ld;

mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt")
ll mod,tt,v1,v2,d,n,g[2000009],bs;
vector<pll> A[2000009],B[2000009];
vector<ppl> D;
unordered_map<ll,ll> mp;
ll f(ll x,ll y){
   return (ll)x*(2*n+1)+y;
}
ll p(ll x,ll y){
   x=f(x,y);
   if(mp.count(x)) return mp[x];
   else return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    mod=1e9+7;
    cin>>tt;
    while(tt--){
        cin>>n;
        bs=800;
        for(int i=1;i<=2*n;i++) g[i]=0;
        for(int i=1;i<=2*n;i++) A[i].clear();
        for(int i=1;i<=2*n;i++) B[i].clear();

        mp.clear();
        for(int i=1;i<=n;i++) {
            cin>>v1>>v2>>d;
            g[v1]+=d;
            g[v2]+=d;
            if(v1>v2) swap(v1,v2);
            A[v1].push_back({v2,d});
            A[v2].push_back({v1,d});
            mp[f(v1,v2)]+=d;
            D.push_back({{v1,v2},d});
        }
        ll res=0;
        for(int i=1;i<=2*n;i++) res=max(res,g[i]);

        for(int i=1;i<=2*n;i++) {
                if(A[i].size()<bs) {
                    sort(A[i].begin(),A[i].end());
                    for(int j=0;j<A[i].size();j++) for(int h=j+1;h<A[i].size();h++) {
                            res=max(res,A[i][j].second+A[i][h].second+p(A[i][j].first,A[i][h].first));
                    }
                }
        }
        ll N=D.size();
        mp.clear();
        for(int a=0;a<N;a++) if(A[D[a].first.first].size()>=bs && A[D[a].first.second].size()>=bs) {
            B[D[a].first.first].push_back({D[a].first.second,D[a].second});
            B[D[a].first.second].push_back({D[a].first.first,D[a].second});
            mp[f(D[a].first.first,D[a].first.second)]+=D[a].second;
        }
         for(int i=1;i<=2*n;i++) {
                if(A[i].size()>=bs) {
                    sort(B[i].begin(),B[i].end());
                    for(int j=0;j<B[i].size();j++) for(int h=j+1;h<B[i].size();h++) {
                            res=max(res,B[i][j].second+B[i][h].second+p(B[i][j].first,B[i][h].first));
                    }
                }
        }
        cout<<res<<"\n";



    }





    return 0;
}
